com.smartgwt.client.tools

## Class EditTree

- java.lang.Object
- - com.google.gwt.user.client.ui.UIObject
  - - com.google.gwt.user.client.ui.Widget
    - - com.smartgwt.client.widgets.BaseWidget
      - - com.smartgwt.client.widgets.Canvas
        - - com.smartgwt.client.widgets.layout.Layout
          - - com.smartgwt.client.widgets.layout.VLayout
            - - com.smartgwt.client.widgets.grid.ListGrid
              - - com.smartgwt.client.widgets.tree.TreeGrid
                - - com.smartgwt.client.tools.EditTree

- All Implemented Interfaces:
    com.google.gwt.event.logical.shared.HasAttachHandlers, com.google.gwt.event.shared.HasHandlers, com.google.gwt.user.client.EventListener, com.google.gwt.user.client.ui.HasVisibility, com.google.gwt.user.client.ui.IsWidget, LogicalStructure, EditContext, DataBoundComponent, HasClickHandlers, HasDoubleClickHandlers, HasDragCompleteHandlers, HasDragMoveHandlers, HasDragRepositionMoveHandlers, HasDragRepositionStartHandlers, HasDragRepositionStopHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasDropCompleteHandlers, HasDropHandlers, HasDropMoveHandlers, HasDropOutHandlers, HasDropOverHandlers, HasFetchDataHandlers, HasFocusChangedHandlers, HasFormulaUpdatedHandlers, HasHoverHandlers, HasHoverHiddenHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseStillDownHandlers, HasMouseUpHandlers, HasMouseWheelHandlers, HasMovedHandlers, HasParentMovedHandlers, HasResizedHandlers, HasRightMouseDownHandlers, HasScrolledHandlers, HasShowContextMenuHandlers, HasVisibilityChangedHandlers, HasBodyKeyPressHandlers, HasCellClickHandlers, HasCellContextClickHandlers, HasCellDoubleClickHandlers, HasCellHoverHandlers, HasCellMouseDownHandlers, HasCellMouseUpHandlers, HasCellOutHandlers, HasCellOverHandlers, HasCellSavedHandlers, HasCellSelectionChangedHandlers, HasCellValueHoverHandlers, HasDataArrivedHandlers, HasDrawAreaChangedHandlers, HasEditCompleteHandlers, HasEditFailedHandlers, HasEditorEnterHandlers, HasEditorExitHandlers, HasFieldStateChangedHandlers, HasFilterEditorSubmitHandlers, HasGroupByCompleteHandlers, HasGroupByHandlers, HasGroupStateChangedHandlers, HasHeaderClickHandlers, HasHeaderDoubleClickHandlers, HasHeaderHoverHandlers, HasHilitesChangedHandlers, HasRecordClickHandlers, HasRecordCollapseHandlers, HasRecordDoubleClickHandlers, HasRecordDropHandlers, HasRecordExpandHandlers, HasRemoveRecordClickHandlers, HasRowContextClickHandlers, HasRowEditorEnterHandlers, HasRowEditorExitHandlers, HasRowHoverHandlers, HasRowMouseDownHandlers, HasRowMouseUpHandlers, HasRowOutHandlers, HasRowOverHandlers, HasSelectionChangedHandlers, HasSelectionUpdatedHandlers, HasSortChangedHandlers, HasSorterClickHandlers, HasSorterContextClickHandlers, HasViewStateChangedHandlers, HasMembersChangedHandlers, HasFolderClickHandlers, HasFolderClosedHandlers, HasFolderContextClickHandlers, HasFolderDropHandlers, HasFolderOpenedHandlers, HasLeafClickHandlers, HasLeafContextClickHandlers, HasNodeClickHandlers, HasNodeContextClickHandlers

      public class EditTree
      extends TreeGrid
      implements EditContext

  A TreeGrid that allows drag and drop creation and manipulation of a tree of objects described by DataSources.

  Nodes can be added via drag and drop from a `Palette` or may be programmatically added via `addNode()`. Nodes may be dragged within the tree to reparent them.

  Eligibility to be dropped on any given node is determined by inspecting the DataSource of the parent node. Drop is allowed only if the parent schema has a field which accepts the type of the dropped node.

  On successful drop, the newly created component will be added to the parent node under the detected field. Array fields, declared by setting `dataSourceField.multiple:true`, are supported.

  An EditTree is initialized by setting `rootComponent`. EditTree.data (the Tree instance) should never be directly set or looked at.

  See Also:
    `DevTools overview and related methods`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

      `com.google.gwt.user.client.ui.UIObject.DebugIdImpl, com.google.gwt.user.client.ui.UIObject.DebugIdImplEnabled`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

      `config, configOnly, id, nativeObject, scClassName`

    - ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

      `DEBUG_ID_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EditTree()`
    `EditTree(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `EditNode` | `addFromPaletteNode(PaletteNode paletteNode)` Creates a new EditNode from a PaletteNode, using the `defaultPalette`.
    `EditNode` | `addFromPaletteNode(PaletteNode paletteNode, EditNode parentNode)` Creates a new EditNode from a PaletteNode, using the `defaultPalette`.
    `EditNode[]` | `addFromPaletteNodes(PaletteNode[] paletteNodes)` Add the supplied `PaletteNodes` to the parentNode, preserving internal references from one supplied PaletteNode to another.
    `EditNode[]` | `addFromPaletteNodes(PaletteNode[] paletteNodes, EditNode parentNode)` Add the supplied `PaletteNodes` to the parentNode, preserving internal references from one supplied PaletteNode to another.
    `EditNode` | `addNode(EditNode newNode)` Add a new `EditNode` to the EditContext, under the specified parent.
    `EditNode` | `addNode(EditNode newNode, EditNode parentNode)`
    `EditNode` | `addNode(EditNode newNode, EditNode parentNode, java.lang.Integer index)`
    `EditNode` | `addNode(EditNode newNode, EditNode parentNode, java.lang.Integer index, java.lang.String parentProperty)`
    `EditNode` | `addNode(EditNode newNode, EditNode parentNode, java.lang.Integer index, java.lang.String parentProperty, java.lang.Boolean skipParentComponentAdd)` Add a new `EditNode` to the EditContext, under the specified parent.
    `void` | `addPaletteNodesFromJS(java.lang.String jsCode)` Add `PaletteNodes` from a JavaScript source representation.
    `void` | `addPaletteNodesFromJS(java.lang.String jsCode, EditNode parentNode)`
    `void` | `addPaletteNodesFromJS(java.lang.String jsCode, EditNode parentNode, java.lang.String[] globals)` Add `PaletteNodes` from a JavaScript source representation.
    `void` | `addPaletteNodesFromJSON(java.lang.String jsonString)` Recreate `EditNodes` from a JSON representation of `PaletteNodes` (possibly created by calling `EditContext.serializeAllEditNodesAsJSON()` or `EditContext.serializeEditNodesAsJSON()`.
    `void` | `addPaletteNodesFromJSON(java.lang.String jsonString, EditNode parentNode)`
    `void` | `addPaletteNodesFromJSON(java.lang.String jsonString, EditNode parentNode, java.lang.String[] globals)` Recreate `EditNodes` from a JSON representation of `PaletteNodes` (possibly created by calling `EditContext.serializeAllEditNodesAsJSON()` or `EditContext.serializeEditNodesAsJSON()`.
    `void` | `addPaletteNodesFromXML(java.lang.String xmlString)` Recreate `EditNodes` from an XML representation of `PaletteNodes` (possibly created by calling `EditContext.serializeAllEditNodes()` or `EditContext.serializeEditNodes()`.
    `void` | `addPaletteNodesFromXML(java.lang.String xmlString, EditNode parentNode)`
    `void` | `addPaletteNodesFromXML(java.lang.String xmlString, EditNode parentNode, java.lang.String[] globals)` Recreate `EditNodes` from an XML representation of `PaletteNodes` (possibly created by calling `EditContext.serializeAllEditNodes()` or `EditContext.serializeEditNodes()`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `protected com.google.gwt.core.client.JavaScriptObject` | `create()`
    `void` | `destroyAll()` Removes all `EditNodes` from the EditContext, and calls `destroy()` on the `liveObjects`.
    `Palette` | `getDefaultPalette()` `Palette` to use when an `EditNode` is being created directly by this EditContext, instead of being created due to a user interaction with a palette (eg dragging from a `TreePalette`, or clicking on `MenuPalette`).
    `Palette[]` | `getExtraPalettes()` Additional `Palettes` to consult for metadata when deserializing `Edit Nodes`.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `getLogicalStructure()`
    `static EditTree` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `void` | `getPaletteNodesFromJS(java.lang.String jsCode, PaletteNodeCallback callback)` Obtain `PaletteNodes` from a JavaScript source representation.
    `void` | `getPaletteNodesFromJS(java.lang.String jsCode, PaletteNodeCallback callback, java.lang.String[] globals)` Obtain `PaletteNodes` from a JavaScript source representation.
    `void` | `getPaletteNodesFromXML(java.lang.String xmlString, PaletteNodeCallback callback)` Obtain `PaletteNodes` from an XML representation, but do not add them to the EditContext.
    `boolean` | `getPersistCoordinates()` If enabled, changes to a `liveObject`'s position and size will be persisted to their `EditNodes`.
    `Record` | `getRootComponent()` Root of data to edit.
    `EditNode` | `makeEditNode(PaletteNode paletteNode)` Creates and returns an EditNode using the `defaultPalette`.
    `void` | `removeAll()` Removes all `EditNodes` from the EditContext, but does not destroy the `liveObjects`.
    `void` | `removeNodeProperties(EditNode editNode, java.lang.String[] properties)` Removes the specified properties from an editNode's serializable "defaults".
    `java.lang.String` | `serializeAllEditNodes()` Serialize the tree of `EditNodes` to an XML representation of `PaletteNodes`.
    `java.lang.String` | `serializeAllEditNodes(java.lang.Boolean serverless)` Serialize the tree of `EditNodes` to an XML representation of `PaletteNodes`.
    `java.lang.String` | `serializeAllEditNodesAsJSON()` Encode the tree of `EditNodes` to a JSON representation of `PaletteNodes`.
    `java.lang.String` | `serializeAllEditNodesAsJSON(java.lang.Boolean serverless)` Encode the tree of `EditNodes` to a JSON representation of `PaletteNodes`.
    `java.lang.String` | `serializeEditNodes(EditNode[] nodes)` Serialize the provided `EditNodes` to an XML representation of `PaletteNodes`.
    `java.lang.String` | `serializeEditNodes(EditNode[] nodes, java.lang.Boolean serverless)` Serialize the provided `EditNodes` to an XML representation of `PaletteNodes`.
    `java.lang.String` | `serializeEditNodesAsJSON(EditNode[] nodes)` Serialize the provided `EditNodes` to a JSON representation of `PaletteNodes`.
    `java.lang.String` | `serializeEditNodesAsJSON(EditNode[] nodes, java.lang.Boolean serverless)` Serialize the provided `EditNodes` to a JSON representation of `PaletteNodes`.
    `void` | `setDefaultPalette(Palette defaultPalette)` `Palette` to use when an `EditNode` is being created directly by this EditContext, instead of being created due to a user interaction with a palette (eg dragging from a `TreePalette`, or clicking on `MenuPalette`).
    `static void` | `setDefaultProperties(EditTree editTreeProperties)` Class level method to set the default properties of this class.
    `void` | `setExtraPalettes(Palette... extraPalettes)` Additional `Palettes` to consult for metadata when deserializing `Edit Nodes`.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `setLogicalStructure(com.smartgwt.logicalstructure.widgets.tools.EditTreeLogicalStructure s)`
    `void` | `setNodeProperties(EditNode editNode, Canvas properties)` Update an editNode's serializable "defaults" with the supplied properties.
    `void` | `setNodeProperties(EditNode editNode, Canvas properties, java.lang.Boolean skipLiveObjectUpdate)` Update an editNode's serializable "defaults" with the supplied properties.
    `void` | `setPersistCoordinates(boolean persistCoordinates)` If enabled, changes to a `liveObject`'s position and size will be persisted to their `EditNodes`.
    `void` | `setRootComponent(Record rootComponent)` Root of data to edit.

    - ### Methods inherited from class com.smartgwt.client.widgets.tree.TreeGrid

      `addDataArrivedHandler, addFolderClickHandler, addFolderClosedHandler, addFolderContextClickHandler, addFolderDropHandler, addFolderOpenedHandler, addLeafClickHandler, addLeafContextClickHandler, addNodeClickHandler, addNodeContextClickHandler, addRecordDropHandler, canEditCell, closeFolder, exportClientData, exportClientData, exportClientData, fetchData, fetchData, fetchData, fetchData, filterData, filterData, filterData, getAlwaysShowOpener, getAnimateFolderEffect, getAnimateFolderMaxRows, getAnimateFolders, getAnimateFolderSpeed, getAnimateFolderTime, getAutoFetchTextMatchStyle, getAutoPreserveOpenState, getCanAcceptDroppedRecords, getCanDragRecordsOut, getCanDropOnLeaves, getCanReorderRecords, getCanReparentNodes, getCanSelectAll, getCantDragIntoChildMessage, getCantDragIntoSelfMessage, getCascadeSelection, getCellAlign, getClosedIconSuffix, getConnectorImage, getCreateDefaultTreeField, getCustomIconDropProperty, getCustomIconOpenProperty, getCustomIconProperty, getData, getDataFetchMode, getDataProperties, getDisplayNodeType, getDropFolder, getDropIconSuffix, getEventRow, getEventRow, getExtraIcon, getExtraIconGap, getFolderIcon, getIcon, getIconSize, getIndentRecordComponents, getIndentSize, getKeepParentsOnFilter, getLeaveSelectionCheckboxGap, getLoadDataOnDemand, getManyItemsImage, getNodeIcon, getNodeTitle, getOfflineNodeMessage, getOpenerIconHeight, getOpenerIconSize, getOpenerIconWidth, getOpenerImage, getOpenIcon, getOpenIconSuffix, getOpenState, getParentAlreadyContainsChildMessage, getRecord, getRecordDropAppearance, getRecords, getSelectedPaths, getSelectedRecord, getSelectionProperty, getSeparateFolders, getServerFilterFields, getShowConnectors, getShowCustomIconDrop, getShowCustomIconOpen, getShowDisabledSelectionCheckbox, getShowDropIcons, getShowFullConnectors, getShowOpener, getShowOpenIcons, getShowPartialSelection, getShowRoot, getSortFoldersBeforeLeaves, getTestInstance, getTree, getTreeFieldTitle, getTreeRootValue, getUseAllDataSourceFields, isExportingClientData, isOverExtraIcon, isOverOpenArea, onInit, openFolder, recordDoubleClick, setAlwaysShowOpener, setAnimateFolderEffect, setAnimateFolderMaxRows, setAnimateFolders, setAnimateFolderSpeed, setAnimateFolderTime, setAutoFetchTextMatchStyle, setAutoPreserveOpenState, setCanAcceptDroppedRecords, setCanDragRecordsOut, setCanDropOnLeaves, setCanReorderRecords, setCanReparentNodes, setCanSelectAll, setCantDragIntoChildMessage, setCantDragIntoSelfMessage, setCascadeSelection, setCellValueHoverFormatter, setClosedIconSuffix, setConnectorImage, setCreateDefaultTreeField, setCustomIconDropProperty, setCustomIconOpenProperty, setCustomIconProperty, setCustomNodeIcon, setData, setDataFetchMode, setDataProperties, setDefaultProperties, setDisplayNodeType, setDropIconSuffix, setExtraIconGap, setFields, setFolderIcon, setIconSize, setIndentRecordComponents, setIndentSize, setInitialData, setKeepParentsOnFilter, setLeaveSelectionCheckboxGap, setLoadDataOnDemand, setLogicalStructure, setManyItemsImage, setNodeIcon, setOfflineNodeMessage, setOpenerIconHeight, setOpenerIconSize, setOpenerIconWidth, setOpenerImage, setOpenIconSuffix, setOpenState, setParentAlreadyContainsChildMessage, setRecordDropAppearance, setSelectedPaths, setSelectionProperty, setSeparateFolders, setServerFilterFields, setShowConnectors, setShowCustomIconDrop, setShowCustomIconOpen, setShowDisabledSelectionCheckbox, setShowDropIcons, setShowFullConnectors, setShowOpener, setShowOpenIcons, setShowPartialSelection, setShowRoot, setSortFoldersBeforeLeaves, setTreeFieldTitle, setTreeRootValue, setTreeRootValue, setUseAllDataSourceFields, startEditingNew, toggleFolder, transferNodes, transferNodes, willAcceptDrop`

    - ### Methods inherited from class com.smartgwt.client.widgets.grid.ListGrid

      `addBodyKeyPressHandler, addCellClickHandler, addCellContextClickHandler, addCellDoubleClickHandler, addCellHoverHandler, addCellMouseDownHandler, addCellMouseUpHandler, addCellOutHandler, addCellOverHandler, addCellSavedHandler, addCellSelectionChangedHandler, addCellValueHoverHandler, addData, addData, addData, addDataArrivedHandler, addDragCompleteHandler, addDrawAreaChangedHandler, addDropCompleteHandler, addEditCompleteHandler, addEditFailedHandler, addEditorEnterHandler, addEditorExitHandler, addEmbeddedComponent, addEmbeddedComponent, addEmbeddedComponent, addEmbeddedComponent, addFetchDataHandler, addFieldStateChangedHandler, addFilterEditorSubmitHandler, addFormulaField, addFormulaUpdatedHandler, addGroupByCompleteHandler, addGroupByHandler, addGroupStateChangedHandler, addHeaderClickHandler, addHeaderDoubleClickHandler, addHeaderHoverHandler, addHilitesChangedHandler, addRecordClickHandler, addRecordCollapseHandler, addRecordDoubleClickHandler, addRecordExpandHandler, addRemoveRecordClickHandler, addRowContextClickHandler, addRowEditorEnterHandler, addRowEditorExitHandler, addRowHoverHandler, addRowMouseDownHandler, addRowMouseUpHandler, addRowOutHandler, addRowOverHandler, addSelectionChangedHandler, addSelectionUpdatedHandler, addSort, addSortChangedHandler, addSorterClickHandler, addSorterContextClickHandler, addSummaryField, addViewStateChangedHandler, anySelected, applyCellData, applyRecordData, autoFitField, autoFitFields, autoFitFields, cancelEditing, canEditCell, canExpandRecord, canSelectCell, canSelectRecord, cellHasChanges, cellHasErrors, cellHasErrors, cellValueHoverHTML, cellValueIsClipped, chartData, chartData, chartData, chartData, chartData, clearCriteria, clearCriteria, clearCriteria, clearEditValue, clearFieldError, clearFieldError, clearRowErrors, clearSort, closeRecord, collapseRecord, collapseRecords, configureGrouping, createRecordComponent, deselectAllRecords, deselectRange, deselectRecord, deselectRecord, deselectRecords, deselectRecords, disableHilite, disableHiliting, discardAllEdits, discardAllEdits, discardAllEdits, discardEdits, discardEdits, displayHeaderContextMenu, editFields, editHilites, enableHilite, enableHilite, enableHiliting, enableHiliting, endEditing, expandRecord, expandRecords, exportData, exportData, fetchRelatedData, fetchRelatedData, fetchRelatedData, fetchRelatedData, fetchRelatedData, fieldIsVisible, filterByEditor, filterData, find, findAll, findIndex, findNextIndex, findNextIndex, focusInCell, focusInFilterEditor, focusInFilterEditor, focusInRow, freezeField, freezeField, freezeField, freezeField, freezeFields, freezeFields, getAddDropValues, getAddFormulaFieldText, getAddOperation, getAddSummaryFieldText, getAdvancedFieldPickerThreshold, getAllEditRows, getAllFields, getAllowFilterExpressions, getAllowRowSpanning, getAlternateBodyStyleName, getAlternateFieldFrequency, getAlternateFieldStyles, getAlternateRecordFrequency, getAlternateRecordStyles, getAlwaysShowEditors, getAnimateRemoveRecord, getAnimateRemoveSpeed, getAnimateRemoveTime, getAnimateRollOver, getAnimateRollUnder, getAnimateSelection, getAnimateSelectionUnder, getApplyFormulaAfterSummary, getApplyRowNumberStyle, getArrowKeyAction, getAsynchGroupingPrompt, getAutoFetchAsFilter, getAutoFetchData, getAutoFetchDisplayMap, getAutoFitAllText, getAutoFitClipFields, getAutoFitData, getAutoFitExpandField, getAutoFitExtraRecords, getAutoFitFieldsFillViewport, getAutoFitFieldText, getAutoFitFieldWidths, getAutoFitHeaderHeights, getAutoFitIconFields, getAutoFitMaxColumns, getAutoFitMaxHeight, getAutoFitMaxRecords, getAutoFitMaxWidth, getAutoFitWidthApproach, getAutoSaveEdits, getAutoSizeHeaderSpans, getBackgroundComponent, getBadFormulaResultValue, getBaseStyle, getBaseStyle, getBody, getBodyBackgroundColor, getBodyOverflow, getBodyScrollLeft, getBodyScrollTop, getBodyStyleName, getBooleanBaseStyle, getBooleanFalseImage, getBooleanImageHeight, getBooleanImageWidth, getBooleanPartialImage, getBooleanTrueImage, getCanAddFormulaFields, getCanAddSummaryFields, getCanAutoFitFields, getCancelEditingConfirmationMessage, getCanCollapseGroup, getCanDragSelect, getCanDragSelectText, getCanDropInEmptyArea, getCanEdit, getCanEditFieldAttribute, getCanEditHilites, getCanEditTitles, getCanExpandMultipleRecords, getCanExpandRecordProperty, getCanExpandRecords, getCanFocusInEmptyGrid, getCanFreezeFields, getCanGroupBy, getCanHover, getCanMultiGroup, getCanMultiSort, getCanPickFields, getCanPickOmittedFields, getCanRemoveRecords, getCanReorderFields, getCanResizeFields, getCanSelectCells, getCanSort, getCanTabToHeader, getCellContextMenu, getCellCSSText, getCellErrors, getCellHeight, getCellHoverComponent, getCellPadding, getCellPageRect, getCellRowSpan, getCellSelection, getCellStartRow, getCellStyle, getChartConstructor, getChartType, getCheckboxFieldFalseImage, getCheckboxFieldImageHeight, getCheckboxFieldImageWidth, getCheckboxFieldPartialImage, getCheckboxFieldTrueImage, getChildExpansionMode, getClearAllSortingText, getClearFilterText, getClearSortFieldText, getClipHeaderTitles, getColumnLeft, getColumnPageLeft, getColumnWidth, getConfigureGroupingText, getConfigureSortText, getConfirmCancelEditing, getConfirmDiscardEdits, getConfirmDiscardEditsMessage, getCriteria, getCurrentExpansionComponent, getCurrentExpansionComponent, getDataAsJSList, getDataAsRecordList, getDataPageSize, getDataSource, getDateFormatter, getDatetimeFormatter, getDefaultFields, getDefaultFieldWidth, getDefaultFormattedFieldValue, getDefaultFormattedFieldValue, getDefaultFormattedFieldValue, getDefaultFormattedValue, getDeferRemoval, getDetailDS, getDetailField, getDiscardEditsOnHideField, getDiscardEditsSaveButtonTitle, getDisplayValue, getDisplayValue, getDisplayValue, getDisplayValue, getDisplayValue, getDragData, getDragDataAction, getDragTrackerMode, getDragTrackerStyle, getDrawAheadRatio, getDrawAllMaxCells, getDrawArea, getDrawnRowHeight, getDrawnRows, getDropCriteriaOnHideField, getDropValues, getDuplicateDragMessage, getEditByCell, getEditCol, getEditedCell, getEditedCell, getEditedCell, getEditedCell, getEditedRecord, getEditEvent, getEditFailedBaseStyle, getEditFailedCSSText, getEditFormItem, getEditFormItem, getEditFormulaFieldText, getEditOnF2Keypress, getEditOnFocus, getEditPendingBaseStyle, getEditPendingCSSText, getEditRow, getEditSummaryFieldText, getEditValue, getEditValue, getEditValueAsBoolean, getEditValueAsDate, getEditValueAsFloat, getEditValueAsInt, getEditValueAsRecord, getEditValueAsRecordArray, getEditValueAsString, getEditValues, getEditValues, getEmptyCellValue, getEmptyMessage, getEmptyMessageStyle, getEnforceVClipping, getEnterKeyEditAction, getEnumCriteriaAsInitialValues, getErrorIconHeight, getErrorIconSrc, getErrorIconWidth, getEscapeKeyEditAction, getEventColumn, getEventColumn, getExpansionCanEdit, getExpansionComponent, getExpansionComponentPoolingMode, getExpansionDetailField, getExpansionDetailRelated, getExpansionDetails, getExpansionEditor, getExpansionEditorCollapseOnSave, getExpansionEditorSaveButton, getExpansionEditorSaveButtonTitle, getExpansionEditorSaveDialogPrompt, getExpansionEditorShowSaveDialog, getExpansionField, getExpansionFieldFalseImage, getExpansionFieldImageHeight, getExpansionFieldImageWidth, getExpansionFieldTrueImage, getExpansionLayout, getExpansionMode, getExpansionRelated, getExportAll, getExportAlternateRowBGColor, getExportBGColor, getExportColumnBGColor, getExportDefaultBGColor, getExportFieldAlignments, getExportFields, getExportFieldWidths, getExportHeaderHeights, getExportRawValues, getExportRowBGColor, getExportWidthScale, getExportWrapHeaderTitles, getFetchDelay, getFetchOperation, getField, getField, getFieldName, getFieldNum, getFieldNum, getFieldPickerFieldProperties, getFieldPickerShowSampleValues, getFieldPickerWindow, getFields, getFieldState, getFieldVisibilitySubmenuTitle, getFieldWidth, getFieldWidth, getFilterButtonPrompt, getFilterButtonProperties, getFilterByCell, getFilterEditor, getFilterEditorCriteria, getFilterEditorCriteria, getFilterEditorHeight, getFilterEditorProperties, getFilterLocalData, getFilterOnKeypress, getFixedFieldWidths, getFixedRecordHeights, getFocusRow, getFormulaBuilderSpanTitleSeparator, getFormulaFieldValue, getFreezeFieldText, getFreezeOnLeftText, getFreezeOnRightText, getFrozenBaseStyle, getFrozenHeaderBaseStyle, getFrozenHeaderTitleStyle, getGenerateClickOnEnter, getGenerateClickOnSpace, getGenerateDoubleClickOnEnter, getGenerateDoubleClickOnSpace, getGridComponents, getGridRenderer, getGridSummary, getGridSummaryData, getGridSummaryRecordProperty, getGroupByAsyncThreshold, getGroupByFields, getGroupByFieldSummaries, getGroupByMaxRecords, getGroupByText, getGroupIcon, getGroupIconSize, getGroupIndentSize, getGroupLeadingIndent, getGroupNodeBaseStyle, getGroupNodeStyle, getGroupState, getGroupSummaryData, getGroupSummaryRecordProperty, getGroupSummaryStyle, getGroupTitleColumnProperties, getGroupTitleField, getGroupTree, getHeader, getHeaderAutoFitEvent, getHeaderBackgroundColor, getHeaderBarStyle, getHeaderBaseStyle, getHeaderButtonProperties, getHeaderContextMenu, getHeaderContextMenuItems, getHeaderHeight, getHeaderHoverAlign, getHeaderHoverHeight, getHeaderHoverOpacity, getHeaderHoverStyle, getHeaderHoverVAlign, getHeaderHoverWidth, getHeaderHoverWrap, getHeaderMenuButton, getHeaderMenuButtonHeight, getHeaderMenuButtonIcon, getHeaderMenuButtonIconHeight, getHeaderMenuButtonIconWidth, getHeaderMenuButtonWidth, getHeaderSpan, getHeaderSpanContextMenuItems, getHeaderSpanHeight, getHeaderTitleStyle, getHiliteCanReplaceValue, getHiliteEditorSpanTitleSeparator, getHiliteHTMLAfterFormat, getHiliteIconHeight, getHiliteIconLeftPadding, getHiliteIconPosition, getHiliteIconRightPadding, getHiliteIcons, getHiliteIconSize, getHiliteIconWidth, getHiliteProperty, getHiliteReplaceValueFieldTitle, getHiliteRowOnFocus, getHilites, getHiliteState, getHoverMode, getHoverStyle, getIconPadding, getImageSize, getIncludeHilitesInSummaryFields, getIncludeInSummaryProperty, getInitialCriteria, getInitialSort, getInstantScrollTrackRedraw, getInvalidSummaryValue, getIsGrouped, getIsSeparatorProperty, getLeaveScrollbarGap, getLinkTextProperty, getListEndEditAction, getLoadingDataMessage, getLoadingDataMessageStyle, getLoadingMessage, getLocateColumnsBy, getLocateRowsBy, getLongTextEditorThreshold, getLongTextEditorType, getMaxExpandedRecords, getMaxExpandedRecordsPrompt, getMinFieldWidth, getMissingSummaryFieldValue, getModalEditing, getNavigateOnTab, getNeverValidate, getNormalBaseStyle, getNormalCellHeight, getNullGroupTitle, getOfflineMessageStyle, getOriginalRecordList, getOriginalResultSet, getOriginBaseStyle, getPoolComponentsPerColumn, getPreventDuplicates, getPrintAutoFit, getPrintBaseStyle, getPrintBooleanBaseStyle, getPrintBooleanFalseImage, getPrintBooleanPartialImage, getPrintBooleanTrueImage, getPrintCheckboxFieldFalseImage, getPrintCheckboxFieldPartialImage, getPrintCheckboxFieldTrueImage, getPrintHeaderStyle, getPrintMaxRows, getPrintWrapCells, getProgressiveLoading, getQuickDrawAheadRatio, getRecordBaseStyleProperty, getRecordCanRemoveProperty, getRecordCanSelectProperty, getRecordComponent, getRecordComponent, getRecordComponentHeight, getRecordComponentPoolingMode, getRecordComponentPosition, getRecordDetailDSProperty, getRecordDropPosition, getRecordEditProperty, getRecordEnabledProperty, getRecordIndex, getRecordIndex, getRecordList, getRecordSummaryBaseStyle, getRelatedDataSource, getRemovedCSSText, getRemoveFieldDefaults, getRemoveFieldProperties, getRemoveFieldTitle, getRemoveIcon, getRemoveIconSize, getRemoveOperation, getReselectOnUpdate, getReselectOnUpdateNotifications, getResizeFieldsInRealTime, getResultSet, getReverseRTLAlign, getRollOverCanvas, getRollUnderCanvas, getRowEndEditAction, getRowErrors, getRowHeight, getRowNumberField, getRowNumberStart, getRowNumberStyle, getRowPageTop, getRowSpan, getRowSpanEditMode, getRowSpanSelectionMode, getRowTop, getSaveByCell, getSaveLocally, getSaveRequestProperties, getScreenReaderCellSeparator, getScreenReaderRowSeparator, getScrollRedrawDelay, getScrollToCellXPosition, getScrollToCellYPosition, getScrollWheelRedrawDelay, getSelectedCellData, getSelectedRecords, getSelectedRecords, getSelectedState, getSelectHeaderOnSort, getSelection, getSelection, getSelectionAppearance, getSelectionType, getSelectOnEdit, getShowAllColumns, getShowAllRecords, getShowAsynchGroupingPrompt, getShowBackgroundComponents, getShowCellContextMenus, getShowClippedHeaderTitlesOnHover, getShowClippedValuesOnHover, getShowCollapsedGroupSummary, getShowComplexFields, getShowDetailFields, getShowEmptyMessage, getShowErrorIcons, getShowExpansionEditorSaveButton, getShowFilterEditor, getShowGridSummary, getShowGroupSummary, getShowGroupSummaryInHeader, getShowGroupTitleColumn, getShowHeader, getShowHeaderContextMenu, getShowHeaderMenuButton, getShowHeaderSpanTitlesInFormulaBuilder, getShowHeaderSpanTitlesInHiliteEditor, getShowHeaderSpanTitlesInSortEditor, getShowHiddenFields, getShowHilitesInGroupSummary, getShowHover, getShowHoverComponents, getShowRecordComponents, getShowRecordComponentsByCell, getShowRollOver, getShowRollOverCanvas, getShowRollUnderCanvas, getShowRowNumbers, getShowSelectedStyle, getShowSelectionCanvas, getShowSelectionUnderCanvas, getShowSortArrow, getShowSortNumerals, getShowTreeColumnPicker, getShrinkForFreeze, getSingleCellValueProperty, getSkinImgDir, getSort, getSortAscendingImage, getSortDescendingImage, getSortDirection, getSortEditorSpanTitleSeparator, getSorterButtonTitle, getSortField, getSortFieldAscendingText, getSortFieldCount, getSortFieldDescendingText, getSortNumeralHTML, getSortNumeralStyle, getSortSpecifier, getSortState, getSpanContextMenu, getStopOnErrors, getStyleName, getSummaryFieldValue, getSummaryRow, getSummaryRowCriteria, getSummaryRowDataSource, getSummaryRowFetchRequestProperties, getSummaryRowHeight, getSummaryRowStyle, getTallBaseStyle, getTitleField, getTitleFieldValue, getToggleFreezeText, getTotalRows, getTrackerImage, getUnfreezeFieldText, getUngroupText, getUnremoveIcon, getUpdateOperation, getUseAdvancedFieldPicker, getUseCellRollOvers, getUseCopyPasteShortcuts, getUseFlatFields, getUseRemoteValidators, getUseRowSpanStyling, getValidateByCell, getValidateOnChange, getValueIcon, getValueIconHeight, getValueIconLeftPadding, getValueIconRightPadding, getValueIconSize, getValueIconWidth, getViewState, getVirtualScrolling, getVisibleRows, getWaitForSave, getWarnOnRemoval, getWarnOnRemovalMessage, getWarnOnUnmappedValueFieldChange, getWrapCells, getWrapHeaderTitles, groupBy, hasChanges, hasErrors, headerHoverHTML, headerTitleClipped, hideField, hideField, hideFields, hideFields, hideFields, hideFields, invalidateCache, invalidateRecordComponents, isCheckboxField, isExpanded, isExpansionField, isGrouped, isGroupNode, isPartiallySelected, isRowNumberField, isSelected, isSortField, markForRedraw, markForRedraw, markRecordRemoved, markRecordsRemoved, markRecordsRemoved, markSelectionRemoved, onInit_ListGrid, openRecordDetailGrid, openRecordEditor, preloadImages, recalculateGridSummary, recalculateSummaries, recalculateSummaries, recalculateSummaries, recordClick, recordMarkedAsRemoved, refreshCell, refreshCell, refreshCellStyle, refreshFields, refreshRecordComponent, refreshRecordComponent, refreshRow, removeData, removeData, removeData, removeEmbeddedComponent, removeEmbeddedComponent, removeEmbeddedComponent, removeRecordClick, removeSelectedData, removeSelectedData, removeSelectedData, reorderField, reorderFields, resizeField, resort, rowClick, rowClick, rowDoubleClick, rowDoubleClick, rowHasChanges, rowHasErrors, saveAllEdits, saveAllEdits, saveAllEdits, saveEdits, saveEdits, saveEdits, saveEdits, scrollBodyTo, scrollToCell, scrollToCell, scrollToCell, scrollToColumn, scrollToColumn, scrollToRow, scrollToRow, selectAllRecords, selectRange, selectRange, selectRecord, selectRecord, selectRecord, selectRecord, selectRecords, selectRecords, selectRecords, selectRecords, selectSingleRecord, selectSingleRecord, setAddDropValues, setAddFormulaFieldText, setAddOperation, setAddSummaryFieldText, setAdvancedFieldPickerThreshold, setAllowFilterExpressions, setAllowRowSpanning, setAlternateBodyStyleName, setAlternateFieldFrequency, setAlternateFieldStyles, setAlternateRecordFrequency, setAlternateRecordStyles, setAlwaysShowEditors, setAnimateRemoveRecord, setAnimateRemoveSpeed, setAnimateRemoveTime, setAnimateRollOver, setAnimateRollUnder, setAnimateSelection, setAnimateSelectionUnder, setApplyFormulaAfterSummary, setApplyRowNumberStyle, setArrowKeyAction, setAsynchGroupingPrompt, setAutoFetchAsFilter, setAutoFetchData, setAutoFetchDisplayMap, setAutoFitAllText, setAutoFitClipFields, setAutoFitData, setAutoFitExpandField, setAutoFitExtraRecords, setAutoFitFieldsFillViewport, setAutoFitFieldText, setAutoFitFieldWidths, setAutoFitHeaderHeights, setAutoFitIconFields, setAutoFitMaxColumns, setAutoFitMaxHeight, setAutoFitMaxRecords, setAutoFitMaxWidth, setAutoFitWidth, setAutoFitWidthApproach, setAutoSaveEdits, setAutoSizeHeaderSpans, setBadFormulaResultValue, setBaseStyle, setBodyBackgroundColor, setBodyOverflow, setBodyStyleName, setBooleanBaseStyle, setBooleanFalseImage, setBooleanImageHeight, setBooleanImageWidth, setBooleanPartialImage, setBooleanTrueImage, setCanAddFormulaFields, setCanAddSummaryFields, setCanAutoFitFields, setCancelEditingConfirmationMessage, setCanCollapseGroup, setCanDragSelect, setCanDragSelectText, setCanDropInEmptyArea, setCanEdit, setCanEditFieldAttribute, setCanEditHilites, setCanEditTitles, setCanExpandMultipleRecords, setCanExpandRecordProperty, setCanExpandRecords, setCanFocusInEmptyGrid, setCanFreezeFields, setCanGroupBy, setCanHover, setCanMultiGroup, setCanMultiSort, setCanPickFields, setCanPickOmittedFields, setCanRemoveRecords, setCanReorderFields, setCanResizeFields, setCanSelectCells, setCanSort, setCanTabToHeader, setCellFormatter, setCellHeight, setCellPadding, setChartConstructor, setChartType, setCheckboxFieldFalseImage, setCheckboxFieldImageHeight, setCheckboxFieldImageWidth, setCheckboxFieldPartialImage, setCheckboxFieldProperties, setCheckboxFieldTrueImage, setChildExpansionMode, setClearAllSortingText, setClearFilterText, setClearSortFieldText, setClipHeaderTitles, setConfigureGroupingText, setConfigureSortText, setConfirmCancelEditing, setConfirmDiscardEdits, setConfirmDiscardEditsMessage, setCriteria, setData, setData, setData, setDataPageSize, setDataProperties, setDataSource, setDataSource, setDateFormatter, setDateInputFormat, setDatetimeFormatter, setDefaultFields, setDefaultProperties, setDeferRemoval, setDetailDS, setDetailDS, setDetailField, setDiscardEditsOnHideField, setDiscardEditsSaveButtonTitle, setDontAutoDestroyComponent, setDragDataAction, setDragTrackerIconCustomizer, setDragTrackerMode, setDragTrackerStyle, setDragTrackerTitleCustomizer, setDrawAheadRatio, setDrawAllMaxCells, setDropCriteriaOnHideField, setDropValues, setDuplicateDragMessage, setEditByCell, setEditEvent, setEditFailedBaseStyle, setEditFailedCSSText, setEditFormulaFieldText, setEditOnF2Keypress, setEditOnFocus, setEditorCustomizer, setEditorValueMap, setEditorValueMap, setEditPendingBaseStyle, setEditPendingCSSText, setEditSummaryFieldText, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValues, setEmptyCellValue, setEmptyMessage, setEmptyMessageStyle, setEnforceVClipping, setEnterKeyEditAction, setEnumCriteriaAsInitialValues, setErrorIconHeight, setErrorIconSrc, setErrorIconWidth, setEscapeKeyEditAction, setExpansionCanEdit, setExpansionComponentPoolingMode, setExpansionEditorSaveDialogPrompt, setExpansionEditorShowSaveDialog, setExpansionFieldFalseImage, setExpansionFieldImageHeight, setExpansionFieldImageWidth, setExpansionFieldTrueImage, setExpansionMode, setExportAll, setExportAlternateRowBGColor, setExportDefaultBGColor, setExportFieldAlignments, setExportFields, setExportFieldWidths, setExportHeaderHeights, setExportRawValues, setExportWidthScale, setExportWrapHeaderTitles, setFastCellUpdates, setFetchDelay, setFetchOperation, setFieldButtonProperties, setFieldCellIcon, setFieldError, setFieldError, setFieldHeaderBaseStyle, setFieldHeaderTitleStyle, setFieldIcon, setFieldPickerFieldProperties, setFieldPickerShowSampleValues, setFieldProperties, setFields, setFieldState, setFieldTitle, setFieldTitle, setFieldVisibilitySubmenuTitle, setFilterButtonPrompt, setFilterButtonProperties, setFilterByCell, setFilterEditorCriteria, setFilterEditorHeight, setFilterEditorProperties, setFilterEditorProperties, setFilterLocalData, setFilterOnKeypress, setFixedFieldWidths, setFixedRecordHeights, setFormulaBuilderSpanTitleSeparator, setFreezeFieldText, setFreezeOnLeftText, setFreezeOnRightText, setFrozenBaseStyle, setFrozenHeaderBaseStyle, setFrozenHeaderTitleStyle, setGenerateClickOnEnter, setGenerateClickOnSpace, setGenerateDoubleClickOnEnter, setGenerateDoubleClickOnSpace, setGridComponents, setGridComponents, setGridSummaryRecordProperty, setGroupByAsyncThreshold, setGroupByField, setGroupByField, setGroupByFieldSummaries, setGroupByMaxRecords, setGroupByText, setGroupIcon, setGroupIconSize, setGroupIndentSize, setGroupLeadingIndent, setGroupNodeBaseStyle, setGroupNodeStyle, setGroupStartOpen, setGroupStartOpen, setGroupState, setGroupSummaryRecordProperty, setGroupSummaryStyle, setGroupTitleColumnProperties, setGroupTitleField, setHeaderAutoFitEvent, setHeaderBackgroundColor, setHeaderBarStyle, setHeaderBaseStyle, setHeaderButtonProperties, setHeaderHeight, setHeaderHoverAlign, setHeaderHoverFormatter, setHeaderHoverHeight, setHeaderHoverOpacity, setHeaderHoverStyle, setHeaderHoverVAlign, setHeaderHoverWidth, setHeaderHoverWrap, setHeaderMenuButtonHeight, setHeaderMenuButtonIcon, setHeaderMenuButtonIconHeight, setHeaderMenuButtonIconWidth, setHeaderMenuButtonWidth, setHeaderSpanBaseStyle, setHeaderSpanButtonProperties, setHeaderSpanHeaderTitle, setHeaderSpanHeight, setHeaderSpans, setHeaderSpanTitle, setHeaderSpanTitleStyle, setHeaderTitleStyle, setHiliteCanReplaceValue, setHiliteEditorSpanTitleSeparator, setHiliteHTMLAfterFormat, setHiliteIconHeight, setHiliteIconLeftPadding, setHiliteIconPosition, setHiliteIconRightPadding, setHiliteIcons, setHiliteIconSize, setHiliteIconWidth, setHiliteProperty, setHiliteReplaceValueFieldTitle, setHiliteRowOnFocus, setHilites, setHiliteState, setHoverCustomizer, setHoverMode, setHoverStyle, setIconPadding, setImageSize, setIncludeHilitesInSummaryFields, setIncludeInSummaryProperty, setInitialCriteria, setInitialSort, setInstantScrollTrackRedraw, setInvalidSummaryValue, setIsSeparatorProperty, setLeaveHeaderMenuButtonSpace, setLeaveScrollbarGap, setLinkTextProperty, setListEndEditAction, setLoadingDataMessage, setLoadingDataMessageStyle, setLoadingMessage, setLocateColumnsBy, setLocateRowsBy, setLogicalStructure, setLongTextEditorThreshold, setLongTextEditorType, setMaxExpandedRecords, setMaxExpandedRecordsPrompt, setMinFieldWidth, setMissingSummaryFieldValue, setModalEditing, setNavigateOnTab, setNeverValidate, setNormalBaseStyle, setNormalCellHeight, setNullGroupTitle, setOfflineMessageStyle, setOriginBaseStyle, setPoolComponentsPerColumn, setPreventDuplicates, setPrintAutoFit, setPrintBaseStyle, setPrintBooleanBaseStyle, setPrintBooleanFalseImage, setPrintBooleanPartialImage, setPrintBooleanTrueImage, setPrintCheckboxFieldFalseImage, setPrintCheckboxFieldPartialImage, setPrintCheckboxFieldTrueImage, setPrintHeaderStyle, setPrintMaxRows, setPrintWrapCells, setProgressiveLoading, setQuickDrawAheadRatio, setRecordBaseStyleProperty, setRecordCanRemoveProperty, setRecordCanSelectProperty, setRecordComponentHeight, setRecordComponentPoolingMode, setRecordComponentPosition, setRecordDetailDSProperty, setRecordEditProperty, setRecordEnabledProperty, setRecords, setRecordSummaryBaseStyle, setRemovedCSSText, setRemoveFieldProperties, setRemoveFieldTitle, setRemoveIcon, setRemoveIconSize, setRemoveOperation, setReselectOnUpdate, setReselectOnUpdateNotifications, setResizeFieldsInRealTime, setReverseRTLAlign, setRollUnderCanvasProperties, setRowEndEditAction, setRowErrors, setRowErrors, setRowNumberFieldProperties, setRowNumberStart, setRowNumberStyle, setRowSpanEditMode, setRowSpanSelectionMode, setSaveByCell, setSaveLocally, setSaveRequestProperties, setScreenReaderCellSeparator, setScreenReaderRowSeparator, setScrollRedrawDelay, setScrollToCellXPosition, setScrollToCellYPosition, setScrollWheelRedrawDelay, setSelectedState, setSelectHeaderOnSort, setSelectionAppearance, setSelectionCanvasProperties, setSelectionType, setSelectionUnderCanvasProperties, setSelectOnEdit, setShowAllColumns, setShowAllRecords, setShowAsynchGroupingPrompt, setShowBackgroundComponents, setShowCellContextMenus, setShowClippedHeaderTitlesOnHover, setShowClippedValuesOnHover, setShowCollapsedGroupSummary, setShowComplexFields, setShowDetailFields, setShowEmptyMessage, setShowErrorIcons, setShowFilterEditor, setShowGridSummary, setShowGroupSummary, setShowGroupSummaryInHeader, setShowGroupTitleColumn, setShowHeader, setShowHeaderContextMenu, setShowHeaderMenuButton, setShowHeaderSpanTitlesInFormulaBuilder, setShowHeaderSpanTitlesInHiliteEditor, setShowHeaderSpanTitlesInSortEditor, setShowHiddenFields, setShowHilitesInGroupSummary, setShowHover, setShowHoverComponents, setShowRecordComponents, setShowRecordComponentsByCell, setShowRollOver, setShowRollOverCanvas, setShowRollUnderCanvas, setShowRowNumbers, setShowSelectedStyle, setShowSelectionCanvas, setShowSelectionUnderCanvas, setShowSortArrow, setShowSortNumerals, setShowTreeColumnPicker, setShrinkForFreeze, setSingleCellValueProperty, setSkinImgDir, setSort, setSortAscendingImage, setSortDescendingImage, setSortDirection, setSortEditorSpanTitleSeparator, setSorterButtonTitle, setSortField, setSortField, setSortField, setSortFieldAscendingText, setSortFieldDescendingText, setSortNumeralStyle, setSortState, setStopOnErrors, setStyleName, setSummaryRowCriteria, setSummaryRowDataSource, setSummaryRowFetchRequestProperties, setSummaryRowHeight, setSummaryRowStyle, setTallBaseStyle, setTitleField, setTrackerImage, setUnfreezeFieldText, setUngroupText, setUnremoveIcon, setUpdateOperation, setUseAdvancedFieldPicker, setUseCellRollOvers, setUseCopyPasteShortcuts, setUseFlatFields, setUseRemoteValidators, setUseRowSpanStyling, setValidateByCell, setValidateOnChange, setValueIconHeight, setValueIconLeftPadding, setValueIconRightPadding, setValueIconSize, setValueIconWidth, setValueMap, setValueMap, setViewState, setVirtualScrolling, setWaitForSave, setWarnOnRemoval, setWarnOnRemovalMessage, setWarnOnUnmappedValueFieldChange, setWrapCells, setWrapHeaderTitles, shouldIncludeHiliteInSummaryField, showField, showField, showFields, showFields, showFields, showFields, showRecordComponent, sort, sort, sort, sort, startEditing, startEditing, startEditing, startEditing, startEditingNew, startEditingNew, startEditingNew, stopHover, summaryUpdated, toggleSort, transferSelectedData, transferSelectedData, unfreezeField, unfreezeField, unfreezeField, unfreezeField, unfreezeFields, unfreezeFields, ungroup, unmarkRecordRemoved, unsort, updateData, updateData, updateData, updateRecordComponent, userSelectAllRecords, validateCell, validateCell, validateRow, willFetchData, willFetchData`

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.VLayout

      `setDefaultProperties, setLogicalStructure`

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.Layout

      `addMember, addMember, addMember, addMember, addMemberPostCreate, addMemberPostCreate, addMemberPreCreate, addMemberPreCreate, addMembers, addMembers, addMembersChangedHandler, getAnimateMembers, getAnimateMemberTime, getCanDropComponents, getDefaultResizeBars, getDropComponent, getDropLine, getDropLineThickness, getDropPosition, getEnforcePolicy, getHPolicy, getLayoutBottomMargin, getLayoutLeftMargin, getLayoutMargin, getLayoutRightMargin, getLayoutTopMargin, getLocateMembersBy, getLocateMembersType, getManagePercentBreadth, getMember, getMember, getMemberDefaultBreadth, getMemberNumber, getMemberNumber, getMemberOverlap, getMembers, getMembersMargin, getMinMemberSize, getOverflow, getPaddingAsLayoutMargin, getResizeBar, getResizeBarClass, getResizeBarSize, getReverseOrder, getShowDragPlaceHolder, getShowDropLines, getStackZIndex, getVertical, getVPolicy, hasMember, hideDropLine, hideMember, hideMember, onInit_Layout, reflow, reflow, reflowNow, removeMember, removeMembers, removeMembers, reorderMember, reorderMembers, setAlign, setAlign, setAnimateMembers, setAnimateMemberTime, setCanDropComponents, setDefaultLayoutAlign, setDefaultLayoutAlign, setDefaultProperties, setDefaultResizeBars, setDropLineProperties, setDropLineThickness, setEnforcePolicy, setHPolicy, setLayoutBottomMargin, setLayoutLeftMargin, setLayoutMargin, setLayoutRightMargin, setLayoutTopMargin, setLocateMembersBy, setLocateMembersType, setLogicalStructure, setManagePercentBreadth, setMemberOverlap, setMembers, setMembersMargin, setMinMemberSize, setOverflow, setPaddingAsLayoutMargin, setPlaceHolderDefaults, setPlaceHolderProperties, setResizeBarClass, setResizeBarSize, setReverseOrder, setShowDragPlaceHolder, setShowDropLines, setStackZIndex, setVertical, setVisibleMember, setVPolicy, showMember, showMember`

    - ### Methods inherited from class com.smartgwt.client.widgets.Canvas

      `addChild, addChild, addChild, addChild, addChild, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addScrolledHandler, addShowContextMenuHandler, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsFocus, containsPoint, containsPoint, deparent, depeer, disable, enable, focus, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaRole, getAutoDraw, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanFocus, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContextMenu, getCursor, getDataPath, getDefaultHeight, getDefaultWidth, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragType, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getElement, getElement, getEventEdge, getEventEdge, getExtraSpace, getFacetId, getFormItemAutoChild, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverComponent, getHoverDelay, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapOrigin, getHSnapOrigin, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getKeepInParentRect, getLayoutAlign, getLeft, getLeftAsString, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMaxHeight, getMaxWidth, getMenuConstructor, getMinHeight, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getNextZIndex, getNoDoubleClicks, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getParentCanvas, getParentElement, getPeers, getPercentBox, getPercentSource, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrompt, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowDepth, getShadowImage, getShadowOffset, getShadowSoftness, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowResizeBar, getShowShadow, getShrinkElementOnHide, getSnapAxis, getSnapEdge, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapResizeToGrid, getSnapTo, getSnapToGrid, getSnapVDirection, getSnapVGap, getTabIndex, getTitle, getTooltip, getTop, getTopAsString, getTopElement, getUseBackMask, getUseDragMask, getUseNativeDrag, getUseOpacityFilter, getValuesManager, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWidth, getVSnapOrigin, getVSnapOrigin, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getZIndex, getZIndex, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, intersects, isDirty, isDisabled, isDrawn, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, parentResized, printComponents, redraw, redraw, removeChild, removeChild, removePeer, removePeer, resizeBy, resizeTo, resizeTo, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAllowExternalFilters, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoDraw, setAutoHeight, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBottom, setCanAcceptDrop, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanFocus, setCanSelectText, setChildren, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContextMenu, setCursor, setDataPath, setDefaultHeight, setDefaultProperties, setDefaultWidth, setDisabled, setDisabledCursor, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragType, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setElement, setExtraSpace, setFacetId, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupTitle, setHeight, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverDelay, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeft, setLeft, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLogicalStructure, setMargin, setMatchElement, setMaxHeight, setMaxWidth, setMenuConstructor, setMinHeight, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setNeverUseFilters, setNoDoubleClicks, setOpacity, setPadding, setPageLeft, setPageTop, setParentCanvas, setParentElement, setPeers, setPercentBox, setPercentSource, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrompt, setRect, setRect, setRedrawOnResize, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setScrollbarConstructor, setScrollbarSize, setShadowDepth, setShadowImage, setShadowOffset, setShadowSoftness, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowResizeBar, setShowShadow, setShrinkElementOnHide, setSmoothFade, setSnapAxis, setSnapEdge, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToGrid, setSnapTo, setSnapToGrid, setSnapVDirection, setSnapVGap, setTabIndex, setTitle, setTooltip, setTop, setTop, setUseBackMask, setUseDragMask, setUseNativeDrag, setUseOpacityFilter, setValuesManager, setVisibility, setVisible, setWidth, setWidth, setWidth, setWidth100, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, updateEditNode, updateHover, updateHover, updateShadow, visibleAtPoint`

    - ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

      `addDrawHandler, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hasAutoAssignedID, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setDragTracker, setID, setJavaScriptObject, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Widget

      `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents`

    - ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

      `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent, unsinkEvents`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

    - ### Methods inherited from interface com.smartgwt.client.widgets.DataBoundComponent

      `getOrCreateJsObj`

- - ### Constructor Detail

    - #### EditTree

          public EditTree()

    - #### EditTree

          public EditTree(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static EditTree getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### create

          protected com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `TreeGrid`

    - #### setRootComponent

          public void setRootComponent(Record rootComponent)
                                throws java.lang.IllegalStateException

      Root of data to edit. Must contain the "_constructor" property, with the name of a valid `schema` or nothing will be able to be dropped on this EditTree.

      Can be retrieved at any time.

      Parameters:
        `rootComponent` - Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `DevTools overview and related methods`

    - #### getRootComponent

          public Record getRootComponent()

      Root of data to edit. Must contain the "_constructor" property, with the name of a valid `schema` or nothing will be able to be dropped on this EditTree.

      Can be retrieved at any time.

      Returns:
        Record
      See Also:
        `DevTools overview and related methods`

    - #### setDefaultPalette

          public void setDefaultPalette(Palette defaultPalette)

      `Palette` to use when an `EditNode` is being created directly by this EditContext, instead of being created due to a user interaction with a palette (eg dragging from a `TreePalette`, or clicking on `MenuPalette`).

      If no defaultPalette is provided, the EditContext uses an automatically created `HiddenPalette`.
      If this method is called after the component has been drawn/initialized: `Palette` to use when an `EditNode` is being created directly by this EditContext, instead of being created due to a user interaction with a palette (eg dragging from a `TreePalette`, or clicking on `MenuPalette`).

      If no defaultPalette is provided, the EditContext uses an automatically created `HiddenPalette`.

      Specified by:
        `setDefaultPalette` in interface `EditContext`
      Parameters:
        `defaultPalette` - the default Palette. Default value is null

    - #### getDefaultPalette

          public Palette getDefaultPalette()

      `Palette` to use when an `EditNode` is being created directly by this EditContext, instead of being created due to a user interaction with a palette (eg dragging from a `TreePalette`, or clicking on `MenuPalette`).

      If no defaultPalette is provided, the EditContext uses an automatically created `HiddenPalette`.

      Specified by:
        `getDefaultPalette` in interface `EditContext`
      Returns:
        `Palette` to use when an `EditNode` is being created directly by this EditContext, instead of being created due to a user interaction with a palette (eg dragging from a `TreePalette`, or clicking on `MenuPalette`).

        If no defaultPalette is provided, the EditContext uses an automatically created `HiddenPalette`.

    - #### setExtraPalettes

          public void setExtraPalettes(Palette... extraPalettes)

      Additional `Palettes` to consult for metadata when deserializing `Edit Nodes`. Note that the `defaultPalette` is always consulted and need not be provided again here.
      Specified by:
        `setExtraPalettes` in interface `EditContext`
      Parameters:
        `extraPalettes` - Default value is null

    - #### getExtraPalettes

          public Palette[] getExtraPalettes()

      Additional `Palettes` to consult for metadata when deserializing `Edit Nodes`. Note that the `defaultPalette` is always consulted and need not be provided again here.
      Specified by:
        `getExtraPalettes` in interface `EditContext`
      Returns:
        Palette...

    - #### setPersistCoordinates

          public void setPersistCoordinates(boolean persistCoordinates)

      If enabled, changes to a `liveObject`'s position and size will be persisted to their `EditNodes`. This applies to both programmatic calls and user interaction (drag reposition or drag resize).
      Specified by:
        `setPersistCoordinates` in interface `EditContext`
      Parameters:
        `persistCoordinates` - Default value is true

    - #### getPersistCoordinates

          public boolean getPersistCoordinates()

      If enabled, changes to a `liveObject`'s position and size will be persisted to their `EditNodes`. This applies to both programmatic calls and user interaction (drag reposition or drag resize).
      Specified by:
        `getPersistCoordinates` in interface `EditContext`
      Returns:
        boolean

    - #### addFromPaletteNode

          public EditNode addFromPaletteNode(PaletteNode paletteNode)

      Creates a new EditNode from a PaletteNode, using the `defaultPalette`. If you have an array of possibly inter-related PaletteNodes, then you should use `addFromPaletteNodes()` on the array instead, in order to preserve the relationships.
      Specified by:
        `addFromPaletteNode` in interface `EditContext`
      Parameters:
        `paletteNode` - the palette node to use to create the new node
      Returns:
        the EditNode created from the paletteNode
      See Also:
        `EditContext.addFromPaletteNodes(com.smartgwt.client.tools.PaletteNode[])`

    - #### addFromPaletteNode

          public EditNode addFromPaletteNode(PaletteNode paletteNode,
                                    EditNode parentNode)

      Creates a new EditNode from a PaletteNode, using the `defaultPalette`. If you have an array of possibly inter-related PaletteNodes, then you should use `addFromPaletteNodes()` on the array instead, in order to preserve the relationships.
      Specified by:
        `addFromPaletteNode` in interface `EditContext`
      Parameters:
        `paletteNode` - the palette node to use to create the new node
        `parentNode` - optional the parent node if the new node should appear under a specific parent
      Returns:
        the EditNode created from the paletteNode
      See Also:
        `EditContext.addFromPaletteNodes(com.smartgwt.client.tools.PaletteNode[])`

    - #### addFromPaletteNodes

          public EditNode[] addFromPaletteNodes(PaletteNode[] paletteNodes)

      Add the supplied `PaletteNodes` to the parentNode, preserving internal references from one supplied PaletteNode to another. This method should be used with an array of possibly inter-related PaletteNodes (for instance, those produced as a result of serialization via `serializeAllEditNodes()`, rather than calling `addFromPaletteNode()` on each individual PaletteNode.
      Specified by:
        `addFromPaletteNodes` in interface `EditContext`
      Parameters:
        `paletteNodes` - array of PaletteNodes
      Returns:
        an array of the EditNodes added to the parentNode
      See Also:
        `EditContext.addFromPaletteNode(com.smartgwt.client.tools.PaletteNode)`

    - #### addFromPaletteNodes

          public EditNode[] addFromPaletteNodes(PaletteNode[] paletteNodes,
                                       EditNode parentNode)

      Add the supplied `PaletteNodes` to the parentNode, preserving internal references from one supplied PaletteNode to another. This method should be used with an array of possibly inter-related PaletteNodes (for instance, those produced as a result of serialization via `serializeAllEditNodes()`, rather than calling `addFromPaletteNode()` on each individual PaletteNode.
      Specified by:
        `addFromPaletteNodes` in interface `EditContext`
      Parameters:
        `paletteNodes` - array of PaletteNodes
        `parentNode` - parent to add to (defaults to the root)
      Returns:
        an array of the EditNodes added to the parentNode
      See Also:
        `EditContext.addFromPaletteNode(com.smartgwt.client.tools.PaletteNode)`

    - #### addNode

          public EditNode addNode(EditNode newNode)

      Add a new `EditNode` to the EditContext, under the specified parent.

      The EditContext will interrogate the parent and new nodes to determine what field within the parent allows a child of this type, and to find a method to add the newNode's liveObject to the parentNode's liveObject. The new relationship will then be stored in the tree of EditNodes.

      For example, when a Tab is dropped on a TabSet, the field TabSet.tabs is discovered as the correct target field via naming conventions, and the method TabSet.addTab() is likewise discovered as the correct method to add a Tab to a TabSet.

      Specified by:
        `addNode` in interface `EditContext`
      Parameters:
        `newNode` - new node to be added
      Returns:
        newNodenode added

    - #### addNode

          public EditNode addNode(EditNode newNode,
                         EditNode parentNode)

      Specified by:
        `addNode` in interface `EditContext`
      See Also:
        `EditTree#addNode()}`

    - #### addNode

          public EditNode addNode(EditNode newNode,
                         EditNode parentNode,
                         java.lang.Integer index)

      Specified by:
        `addNode` in interface `EditContext`
      See Also:
        `EditTree#addNode()}`

    - #### addNode

          public EditNode addNode(EditNode newNode,
                         EditNode parentNode,
                         java.lang.Integer index,
                         java.lang.String parentProperty)

      Specified by:
        `addNode` in interface `EditContext`
      See Also:
        `EditTree#addNode()}`

    - #### addNode

          public EditNode addNode(EditNode newNode,
                         EditNode parentNode,
                         java.lang.Integer index,
                         java.lang.String parentProperty,
                         java.lang.Boolean skipParentComponentAdd)

      Add a new `EditNode` to the EditContext, under the specified parent.

      The EditContext will interrogate the parent and new nodes to determine what field within the parent allows a child of this type, and to find a method to add the newNode's liveObject to the parentNode's liveObject. The new relationship will then be stored in the tree of EditNodes.

      For example, when a Tab is dropped on a TabSet, the field TabSet.tabs is discovered as the correct target field via naming conventions, and the method TabSet.addTab() is likewise discovered as the correct method to add a Tab to a TabSet.

      Specified by:
        `addNode` in interface `EditContext`
      Parameters:
        `newNode` - new node to be added
        `parentNode` - parent to add the new node under.
        `index` - index within the parent's children array
        `parentProperty` - the property of the liveParent to which the new node should be added, if not auto-discoverable from the schema
        `skipParentComponentAdd` - whether to skip adding the liveObject to the liveParent (default false)
      Returns:
        newNodenode added

    - #### addPaletteNodesFromJS

          public void addPaletteNodesFromJS(java.lang.String jsCode)

      Add `PaletteNodes` from a JavaScript source representation.

      By default, components that have `global IDs` will not actually be allowed to take those global IDs - instead, only widgets that have one of the global IDs passed as the `globals` parameter will actually receive their global IDs. To override this behavior, pass the special value `ALL_GLOBALS` for the `globals` parameter.

      Specified by:
        `addPaletteNodesFromJS` in interface `EditContext`
      Parameters:
        `jsCode` - JavaScript code to eval.

    - #### addPaletteNodesFromJS

          public void addPaletteNodesFromJS(java.lang.String jsCode,
                                   EditNode parentNode)

      Specified by:
        `addPaletteNodesFromJS` in interface `EditContext`
      See Also:
        `EditTree#addPaletteNodesFromJS()}`

    - #### addPaletteNodesFromJS

          public void addPaletteNodesFromJS(java.lang.String jsCode,
                                   EditNode parentNode,
                                   java.lang.String[] globals)

      Add `PaletteNodes` from a JavaScript source representation.

      By default, components that have `global IDs` will not actually be allowed to take those global IDs - instead, only widgets that have one of the global IDs passed as the `globals` parameter will actually receive their global IDs. To override this behavior, pass the special value `ALL_GLOBALS` for the `globals` parameter.

      Specified by:
        `addPaletteNodesFromJS` in interface `EditContext`
      Parameters:
        `jsCode` - JavaScript code to eval.
        `parentNode` - parent node (defaults to the root)
        `globals` - widgets to allow to take their global IDs

    - #### addPaletteNodesFromJSON

          public void addPaletteNodesFromJSON(java.lang.String jsonString)

      Recreate `EditNodes` from a JSON representation of `PaletteNodes` (possibly created by calling `EditContext.serializeAllEditNodesAsJSON()` or `EditContext.serializeEditNodesAsJSON()`.

      By default, components that have `global IDs` will not actually be allowed to take those global IDs - instead, only widgets that have one of the global IDs passed as the `globals` parameter will actually receive their global IDs. To override this behavior, pass the special value `ALL_GLOBALS` for the `globals` parameter.

      Specified by:
        `addPaletteNodesFromJSON` in interface `EditContext`
      Parameters:
        `jsonString` - JSON string
      See Also:
        `EditContext.serializeAllEditNodesAsJSON()`, `EditContext.serializeEditNodesAsJSON(com.smartgwt.client.tools.EditNode[])`

    - #### addPaletteNodesFromJSON

          public void addPaletteNodesFromJSON(java.lang.String jsonString,
                                     EditNode parentNode)

      Specified by:
        `addPaletteNodesFromJSON` in interface `EditContext`
      See Also:
        `EditTree#addPaletteNodesFromJSON()}`

    - #### addPaletteNodesFromJSON

          public void addPaletteNodesFromJSON(java.lang.String jsonString,
                                     EditNode parentNode,
                                     java.lang.String[] globals)

      Recreate `EditNodes` from a JSON representation of `PaletteNodes` (possibly created by calling `EditContext.serializeAllEditNodesAsJSON()` or `EditContext.serializeEditNodesAsJSON()`.

      By default, components that have `global IDs` will not actually be allowed to take those global IDs - instead, only widgets that have one of the global IDs passed as the `globals` parameter will actually receive their global IDs. To override this behavior, pass the special value `ALL_GLOBALS` for the `globals` parameter.

      Specified by:
        `addPaletteNodesFromJSON` in interface `EditContext`
      Parameters:
        `jsonString` - JSON string
        `parentNode` - parent node (defaults to the root)
        `globals` - widgets to allow to take their global IDs
      See Also:
        `EditContext.serializeAllEditNodesAsJSON()`, `EditContext.serializeEditNodesAsJSON(com.smartgwt.client.tools.EditNode[])`

    - #### addPaletteNodesFromXML

          public void addPaletteNodesFromXML(java.lang.String xmlString)

      Recreate `EditNodes` from an XML representation of `PaletteNodes` (possibly created by calling `EditContext.serializeAllEditNodes()` or `EditContext.serializeEditNodes()`.

      By default, components that have `global IDs` will not actually be allowed to take those global IDs - instead, only widgets that have one of the global IDs passed as the `globals` parameter will actually receive their global IDs. To override this behavior, pass the special value `ALL_GLOBALS` for the `globals` parameter.

      Specified by:
        `addPaletteNodesFromXML` in interface `EditContext`
      Parameters:
        `xmlString` - XML string
      See Also:
        `EditContext.serializeAllEditNodes()`, `EditContext.serializeEditNodes(com.smartgwt.client.tools.EditNode[])`

    - #### addPaletteNodesFromXML

          public void addPaletteNodesFromXML(java.lang.String xmlString,
                                    EditNode parentNode)

      Specified by:
        `addPaletteNodesFromXML` in interface `EditContext`
      See Also:
        `EditTree#addPaletteNodesFromXML()}`

    - #### addPaletteNodesFromXML

          public void addPaletteNodesFromXML(java.lang.String xmlString,
                                    EditNode parentNode,
                                    java.lang.String[] globals)

      Recreate `EditNodes` from an XML representation of `PaletteNodes` (possibly created by calling `EditContext.serializeAllEditNodes()` or `EditContext.serializeEditNodes()`.

      By default, components that have `global IDs` will not actually be allowed to take those global IDs - instead, only widgets that have one of the global IDs passed as the `globals` parameter will actually receive their global IDs. To override this behavior, pass the special value `ALL_GLOBALS` for the `globals` parameter.

      Specified by:
        `addPaletteNodesFromXML` in interface `EditContext`
      Parameters:
        `xmlString` - XML string
        `parentNode` - parent node (defaults to the root)
        `globals` - widgets to allow to take their global IDs
      See Also:
        `EditContext.serializeAllEditNodes()`, `EditContext.serializeEditNodes(com.smartgwt.client.tools.EditNode[])`

    - #### destroyAll

          public void destroyAll()

      Removes all `EditNodes` from the EditContext, and calls `destroy()` on the `liveObjects`.
      Specified by:
        `destroyAll` in interface `EditContext`

    - #### getPaletteNodesFromJS

          public void getPaletteNodesFromJS(java.lang.String jsCode,
                                   PaletteNodeCallback callback)

      Obtain `PaletteNodes` from a JavaScript source representation.

      By default, components that have `global IDs` will not actually be allowed to take those global IDs - instead, only widgets that have one of the global IDs passed as the `globals` parameter will actually receive their global IDs. To override this behavior, pass the special value `ALL_GLOBALS` for the `globals` parameter.

      Specified by:
        `getPaletteNodesFromJS` in interface `EditContext`
      Parameters:
        `jsCode` - JavaScript code to eval.
        `callback` - Callback used to return the PaletteNodes

    - #### getPaletteNodesFromJS

          public void getPaletteNodesFromJS(java.lang.String jsCode,
                                   PaletteNodeCallback callback,
                                   java.lang.String[] globals)

      Obtain `PaletteNodes` from a JavaScript source representation.

      By default, components that have `global IDs` will not actually be allowed to take those global IDs - instead, only widgets that have one of the global IDs passed as the `globals` parameter will actually receive their global IDs. To override this behavior, pass the special value `ALL_GLOBALS` for the `globals` parameter.

      Specified by:
        `getPaletteNodesFromJS` in interface `EditContext`
      Parameters:
        `jsCode` - JavaScript code to eval.
        `callback` - Callback used to return the PaletteNodes
        `globals` - widgets to allow to take their global IDs

    - #### getPaletteNodesFromXML

          public void getPaletteNodesFromXML(java.lang.String xmlString,
                                    PaletteNodeCallback callback)

      Obtain `PaletteNodes` from an XML representation, but do not add them to the EditContext.
      Specified by:
        `getPaletteNodesFromXML` in interface `EditContext`
      Parameters:
        `xmlString` - XML string
        `callback` - Callback used to return the PaletteNodes
      See Also:
        `EditContext.serializeAllEditNodes()`, `EditContext.serializeEditNodes(com.smartgwt.client.tools.EditNode[])`

    - #### makeEditNode

          public EditNode makeEditNode(PaletteNode paletteNode)

      Creates and returns an EditNode using the `defaultPalette`. Does not add the newly created EditNode to the EditContext.
      Specified by:
        `makeEditNode` in interface `EditContext`
      Parameters:
        `paletteNode` - the palette node to use to create the new node
      Returns:
        the EditNode created from the paletteNode

    - #### removeAll

          public void removeAll()

      Removes all `EditNodes` from the EditContext, but does not destroy the `liveObjects`.
      Specified by:
        `removeAll` in interface `EditContext`

    - #### removeNodeProperties

          public void removeNodeProperties(EditNode editNode,
                                  java.lang.String[] properties)

      Removes the specified properties from an editNode's serializable "defaults". Note that the `liveObject` is not updated by this method. To set a property to null (rather than removing it), use `setNodeProperties()` instead.
      Specified by:
        `removeNodeProperties` in interface `EditContext`
      Parameters:
        `editNode` - the editNode to update
        `properties` - an array of property names to remove
      See Also:
        `EditContext.setNodeProperties(com.smartgwt.client.tools.EditNode, com.smartgwt.client.widgets.Canvas)`

    - #### serializeAllEditNodes

          public java.lang.String serializeAllEditNodes()

      Serialize the tree of `EditNodes` to an XML representation of `PaletteNodes`. The result can be supplied to `addPaletteNodesFromXML()` to recreate the EditNodes.
      Specified by:
        `serializeAllEditNodes` in interface `EditContext`
      Returns:
        an XML representation of PaletteNodes which can be used to recreate the tree of EditNodes.
      See Also:
        `EditContext.addPaletteNodesFromXML(java.lang.String)`

    - #### serializeAllEditNodes

          public java.lang.String serializeAllEditNodes(java.lang.Boolean serverless)

      Serialize the tree of `EditNodes` to an XML representation of `PaletteNodes`. The result can be supplied to `addPaletteNodesFromXML()` to recreate the EditNodes.
      Specified by:
        `serializeAllEditNodes` in interface `EditContext`
      Parameters:
        `serverless` - If true, specify DataSources in full rather than assuming they can be downloaded from the server. Defaults to false.
      Returns:
        an XML representation of PaletteNodes which can be used to recreate the tree of EditNodes.
      See Also:
        `EditContext.addPaletteNodesFromXML(java.lang.String)`

    - #### serializeAllEditNodesAsJSON

          public java.lang.String serializeAllEditNodesAsJSON()

      Encode the tree of `EditNodes` to a JSON representation of `PaletteNodes`. The result can be supplied to `addPaletteNodesFromJSON()` to recreate the EditNodes.
      Specified by:
        `serializeAllEditNodesAsJSON` in interface `EditContext`
      Returns:
        a JSON representation of PaletteNodes which can be used to recreate the tree of EditNodes.
      See Also:
        `EditContext.addPaletteNodesFromJSON(java.lang.String)`

    - #### serializeAllEditNodesAsJSON

          public java.lang.String serializeAllEditNodesAsJSON(java.lang.Boolean serverless)

      Encode the tree of `EditNodes` to a JSON representation of `PaletteNodes`. The result can be supplied to `addPaletteNodesFromJSON()` to recreate the EditNodes.
      Specified by:
        `serializeAllEditNodesAsJSON` in interface `EditContext`
      Parameters:
        `serverless` - If true, specify DataSources in full rather than assuming they can be downloaded from the server. Defaults to false.
      Returns:
        a JSON representation of PaletteNodes which can be used to recreate the tree of EditNodes.
      See Also:
        `EditContext.addPaletteNodesFromJSON(java.lang.String)`

    - #### serializeEditNodes

          public java.lang.String serializeEditNodes(EditNode[] nodes)

      Serialize the provided `EditNodes` to an XML representation of `PaletteNodes`. Note that the EditNodes must have been added to this EditContext. The result can be supplied to `addPaletteNodesFromXML()` to recreate the EditNodes.
      Specified by:
        `serializeEditNodes` in interface `EditContext`
      Parameters:
        `nodes` - EditNodes to be serialized
      Returns:
        an XML representtion of the provided EditNodes

    - #### serializeEditNodes

          public java.lang.String serializeEditNodes(EditNode[] nodes,
                                            java.lang.Boolean serverless)

      Serialize the provided `EditNodes` to an XML representation of `PaletteNodes`. Note that the EditNodes must have been added to this EditContext. The result can be supplied to `addPaletteNodesFromXML()` to recreate the EditNodes.
      Specified by:
        `serializeEditNodes` in interface `EditContext`
      Parameters:
        `nodes` - EditNodes to be serialized
        `serverless` - If true, specify DataSources in full rather than assuming they can be downloaded from the server. Defaults to false.
      Returns:
        an XML representtion of the provided EditNodes

    - #### serializeEditNodesAsJSON

          public java.lang.String serializeEditNodesAsJSON(EditNode[] nodes)

      Serialize the provided `EditNodes` to a JSON representation of `PaletteNodes`. Note that the EditNodes must have been added to this EditContext. The result can be supplied to `addPaletteNodesFromJSON()` to recreate the EditNodes.
      Specified by:
        `serializeEditNodesAsJSON` in interface `EditContext`
      Parameters:
        `nodes` - EditNodes to be serialized
      Returns:
        a JSON representtion of the provided EditNodes

    - #### serializeEditNodesAsJSON

          public java.lang.String serializeEditNodesAsJSON(EditNode[] nodes,
                                                  java.lang.Boolean serverless)

      Serialize the provided `EditNodes` to a JSON representation of `PaletteNodes`. Note that the EditNodes must have been added to this EditContext. The result can be supplied to `addPaletteNodesFromJSON()` to recreate the EditNodes.
      Specified by:
        `serializeEditNodesAsJSON` in interface `EditContext`
      Parameters:
        `nodes` - EditNodes to be serialized
        `serverless` - If true, specify DataSources in full rather than assuming they can be downloaded from the server. Defaults to false.
      Returns:
        a JSON representtion of the provided EditNodes

    - #### setNodeProperties

          public void setNodeProperties(EditNode editNode,
                               Canvas properties)

      Update an editNode's serializable "defaults" with the supplied properties. If you wish to remove a property from the defaults (rather than setting it to null), then use `removeNodeProperties()` instead.
      Specified by:
        `setNodeProperties` in interface `EditContext`
      Parameters:
        `editNode` - the editNode to update
        `properties` - the properties to apply
      See Also:
        `EditContext.removeNodeProperties(com.smartgwt.client.tools.EditNode, java.lang.String[])`

    - #### setNodeProperties

          public void setNodeProperties(EditNode editNode,
                               Canvas properties,
                               java.lang.Boolean skipLiveObjectUpdate)

      Update an editNode's serializable "defaults" with the supplied properties. If you wish to remove a property from the defaults (rather than setting it to null), then use `removeNodeProperties()` instead.
      Specified by:
        `setNodeProperties` in interface `EditContext`
      Parameters:
        `editNode` - the editNode to update
        `properties` - the properties to apply
        `skipLiveObjectUpdate` - whether to skip updating the `liveObject`, e.g. if you have already updated the liveObject
      See Also:
        `EditContext.removeNodeProperties(com.smartgwt.client.tools.EditNode, java.lang.String[])`

    - #### setDefaultProperties

          public static void setDefaultProperties(EditTree editTreeProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `editTreeProperties` - properties that should be used as new defaults when instances of this class are created

    - #### setLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject setLogicalStructure(com.smartgwt.logicalstructure.widgets.tools.EditTreeLogicalStructure s)

    - #### getLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject getLogicalStructure()

      Specified by:
        `getLogicalStructure` in interface `LogicalStructure`
      Overrides:
        `getLogicalStructure` in class `TreeGrid`